/*
    mpwd (Make PassWord)

    Dies Programm erzeugt ein Zufalls-Passwort mit 8 Zeichen, gro -
    kleinschreibung und Zahlen. Benutzt werden /dev/urandom und die
    C-Funktion rand().

    Copyright (c) Andreas Hofmeier

    This program is free software; you can redistribute it and/or
    modify it under the terms of the GNU General Public License as
    published by the Free Software Foundation; either version 2 of
    the License, or (at your option) any later version.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the GNU
    General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with this program; if not, write to the Free Software
    Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.


    Name:     Andreas Hofmeier

    Adresse:  Stralsunder Strae 20
              28239 Bremen
              Germany

    Telefon:  +49-421-613793

    eMail:    An-H@An-H.de
              hofmeier@inbremen.de
              an-h@gmx.de

    Homepage: http://www.An-H.de/
	      hofmeier.home.pages.de
              http://www.LGut.uni-bremen.de/anh/


*/


#include <stdio.h>
#include <stdlib.h>


char blacky_ver_info[] = "make PassWort v0.05 (c) Copyright 1999-2001,2007 Andreas Hofmeier";


//Zahlen, Gross- und Kleinbuchstaben
//wobei die Problematik bei
//0 und o, i und L usw. umgangen worden ist 
char allowed_chars[] = "ABCDEFGHJKLMNPRSTUVWXYZabcdefghijkmnpqrstuvwxyz23456789";


int testifallowed(char c, char *list_of_allowed_chars) {
  int i;
  int len = strlen(list_of_allowed_chars);

  for (i = 0; i < len; i++) {
    if ((unsigned char) c == (unsigned char) list_of_allowed_chars[i]) {
      return 1;
    }
  }

  return 0;
}


main(argc, argv)
  int argc;
  char *argv[];
{
  FILE *f;
  unsigned int seed;
  char count = 0;
  unsigned char c;
  int x;
  int to_lower = 0;

  if ((argc > 1) ? ((argv[1][0] == '-') && (toupper(argv[1][1]) == 'V')) : 0) {
    printf("%s\n\n", blacky_ver_info);
    //    printkinfo(stdout);
    exit(0);
  }

  if ((argc > 1) ? ((argv[1][0] == '-') && (toupper(argv[1][1]) == 'L')) : 0) {
    to_lower = 1;
  }

  if ((f = fopen("/dev/urandom", "r")) == NULL) {
    perror("/dev/urandom");
  }

  fread(&seed, 1, 4, f);
  srand(seed);

  for (  ;  ;  ) {
    if (count >= 8) {
      printf("\n");
      exit(1);
    }
    fread(&c, 1, 1, f);
    //    if (isdigit(c) || isalpha(c)) {
    if (testifallowed(c, allowed_chars)) {
      x = (int) ( 2.0 * rand() / (RAND_MAX + 1.0) );
      if (x > 0) {
	count++;
	if (to_lower) {
	  printf("%c", towlower(c));
	} else {
	  printf("%c", c);
	}
      }
    }
  }
}
